//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "TextImage0.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void JpgToBmp(TImage *image)
{ Graphics::TBitmap *bmp = new Graphics::TBitmap();

  bmp->Width  = image->Picture->Width;
  bmp->Height = image->Picture->Height;
  bmp->Canvas->Draw(0,0,image->Picture->Graphic);
  image->Picture->Bitmap->Assign(bmp);
  image->Refresh();

  delete bmp;
}

void toBinary(TImage *image, int threshold=128)
{ Byte **ptr;
  int r, g, b, gray, index;

  image->Picture->Bitmap->PixelFormat = pf24bit;
  ptr = new Byte*[image->Picture->Height];
  for (int k=0; k<image->Picture->Height; k++)
     ptr[k] = (Byte*) image->Picture->Bitmap->ScanLine[k];
  for (int row=0; row<image->Picture->Height; row++)
     { index = 0;
       for (int col=0; col<image->Picture->Width; col++)
          { b = ptr[row][index  ];
            g = ptr[row][index+1];
            r = ptr[row][index+2];
            gray = 0.299*r + 0.587*g + 0.114*b;
            if ( gray>=threshold ) gray = 255;
            else gray = 0;
            ptr[row][index  ] = (Byte)gray;
            ptr[row][index+1] = (Byte)gray;
            ptr[row][index+2] = (Byte)gray;
            index += 3;
          }
     }
  delete [] ptr;
}

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  Form1->DoubleBuffered = true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Exit1Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Load1Click(TObject *Sender)
{
  if ( OpenDialog1->Execute() )
    { Image1->Picture->LoadFromFile(OpenDialog1->FileName);
      Image1->Top  = 1;
      Image1->Left = 1;
      Graphics::TBitmap *bmp = new Graphics::TBitmap();
      bmp->Width  = Image1->Picture->Width;
      bmp->Height = Image1->Picture->Height;
      bmp->Canvas->Draw(0,0,Image1->Picture->Graphic);
      Image1->Picture->Bitmap->Assign(bmp);
      Image1->Refresh();
      delete bmp;
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  JpgToBmp(Image1);
  toBinary(Image1, 130);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
  Byte *ptr;
  int w, h, index;
  AnsiString line;

  w = Image1->Picture->Width;
  h = Image1->Picture->Height;

  line.SetLength(w); // start from 1
  RichEdit1->Lines->Clear();
  RichEdit1->Font->Size = 1;
  Image1->Picture->Bitmap->PixelFormat = pf24bit;

  for (int y=0; y<h; y++)
     { ptr = (unsigned char *) Image1->Picture->Bitmap->ScanLine[y];
       index = 0;
       for (int x=0; x<w; x++)
          { if ( ptr[index]==255 )
              line[x+1] = '1';
            else line[x+1] = '0';
            index += 3;
          }
       RichEdit1->Lines->Add(line);
     }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnText2ImageClick(TObject *Sender)
{
  Byte *ptr;
  int w, h, index, gray;
  AnsiString line;

  line = RichEdit1->Lines->Strings[0];
  w = line.Length();
  h = RichEdit1->Lines->Count;

  Image1->Picture->Bitmap->Width  = w;
  Image1->Picture->Bitmap->Height = h;
  Image1->Picture->Bitmap->Canvas->Rectangle(Image1->ClientRect);
  Image1->Picture->Bitmap->PixelFormat = pf24bit;

  for (int y=0; y<h; y++)
     { ptr = (unsigned char *) Image1->Picture->Bitmap->ScanLine[y];
       line = RichEdit1->Lines->Strings[y];
       index = 0;

       for (int x=0; x<w; x++)
          { if ( line[x+1]=='1' )  gray=255;
            else gray = 0;

            ptr[index  ] = gray;
            ptr[index+1] = gray;
            ptr[index+2] = gray;

            index += 3;
          }
     }
}
//---------------------------------------------------------------------------

